
# Python Courses in COWI BTM
***Oct. 2019***

<div style="text-align:center"><img src="https://www.python.org/static/community_logos/python-logo-master-v3-TM.png" /></div>

Lately there has been a lot of talk in COWI about digitalization, automation and coding. If you are interested in digging deeper into the world of coding read on.

Starting November 2019 there will be held two COWI Python courses in Lyngby for people who want to sharpen their programming skills. Each course will meet for one hour bi-weekly on alternating weeks. Right now, there are 10 sessions planned for each course.

All course material lives on **GitHub**. Use the links below to view the course material.

## Python 101 - Python for beginners

  * **Beginner course assuming little to no programming experience.**

  * See course material here: [Python 101 - Course material](https://python-crash-course.github.io/Python101/)

## Python 201 - Intermediate Python programming

* **Intermediate course assumes experience comparable to the beginner course**

* See course material here: [Python 201 - Course material](https://python-crash-course.github.io/Python201/)

A typical session will be 10-15 min explanations of topics and 45-50 min for exercises.

## Enroll for the courses [here](http://www.cowiportal.com/com/c000919/_layouts/15/listform.aspx?PageType=8&ListId=%7b35200A22-3290-4197-93AF-A6E8978210F7%7d&RootFolder=)

* It's fine to follow both courses. The beginner course will typically be a week ahead of the intermediate course.

* Enrollment is not binding, so it's perfectly fine to follow along the first couple of sessions and then drop off if the interest declines. You can always go back and look at the material later if need be.

* If you plan to follow Python 201, it would be a good idea to create a [GitHub](https://github.com/) account as we're going to play with Git.

## Who can participate?
Only people located in Lyngby will be able to follow the courses as they are held as physical lunch meetings in the Lyngby office. If they get severely overbooked, we'll have to prioritise people from BTM. 

However, all the course material is made available to everyone and we encourage volunteers from other offices to host similar meetings.

The course will also be useful for people who are not going to be coding often themselves, as it gives a basic knowledge for reading/checking other people's code. There is a lot of merit in understanding the strength and weaknesses and the general workflow used when coding.

## Why Python?
Python is an open source language which has a simple syntax. It's considered one of the easiest programming languages to learn and is according to a bunch of parameters the most popular programming language in the world.

It is a general programming language meaning it can be utilized for all sorts of tasks. In recent years it has been especially popular in the world of scientific computing, data analysis, visualization and machine learning.  
The language is very flexible and allows people to build open source libraries/add-ons for everybody to use. Therefore, there is already a plethora of libraries to perform all kinds of complex operations such as working with advanced data manipulation, plotting, numerical computation, PDF-manipulations and much more.

Moreover, Python is also listed as supported API language for much of the software that we already use. Thus, it can be used to automate repetitive tasks in the daily work.
Examples of software that has Python as API language is SAP2000, Plaxis, Grasshopper, Dynamo and ABAQUS.

**Best regards**,  
KEKL (Kenneth C. Kleissl) and TSJA (Tim Skov Jacobsen)
